import 'package:yuro_cli/core/core.dart';

class YamlUtil {
  YamlUtil._();

  static Future<String> getNativeVersion() async {
    var lockFile = File(join(pubPath, 'global_packages/yuro_cli/pubspec.lock'));
    if (!lockFile.existsSync()) {
      lockFile = File(join(flutterPubPath, 'global_packages/yuro_cli/pubspec.lock'));
      if (!lockFile.existsSync()) {
        Logger.e('yuo can use command "pub global activate yuro_cli" or "flutter pub global activate yuro_cli" to get this cli.');
        return null;
      }
    }
    var yamlMap = loadYaml(lockFile.readAsStringSync()) as YamlMap;
    return yamlMap['packages']['yuro_cli']['version'].toString();
  }

  static Future<bool> registerAssets(String path) async {
    var yamlFile = File(join(projectPath, 'pubspec.yaml'));
    var yamlMap = loadYaml(yamlFile.readAsStringSync()) as YamlMap;
    if (!yamlMap.containsKey('flutter')) {
      yamlFile.writeAsStringSync('\rflutter:', mode: FileMode.append, flush: true);
      yamlMap = loadYaml(yamlFile.readAsStringSync()) as YamlMap;
    }
    var flutter = yamlMap['flutter'] as YamlMap;
    if (flutter == null || !flutter.containsKey('assets')) {
      yamlFile.writeAsStringSync('\r  assets:', mode: FileMode.append, flush: true);
      yamlMap = loadYaml(yamlFile.readAsStringSync()) as YamlMap;
    }
    var assets = flutter['assets'] as YamlList;
    if (assets == null || !assets.contains(path)) {
      yamlFile.writeAsStringSync('\r    - $path', mode: FileMode.append, flush: true);
    }
    var res = await run('flutter', ['pub', 'get']);
    if (res.exitCode != 0) Logger.e(res.stderr);
    return true;
  }
}
